`default_nettype none

// Toplevel module of system project
//  * combine all submodules
// 
// author: 
// date:   
module TOP #(`include "settings.v")
 (input  wire       OSC_CLK,     // 48 MHz oscillator
  input  wire       PO_RSTN,     // asynchronous power on reset (active low)
  input  wire       PB_RSTN,     // asynchronous push button reset (active low)
  input  wire [4:0] SWITCH,      // clock divider settings
  output wire [4:0] LED,         // clock divider indication
  input  wire       VSCALED,     // PGA output voltage
  input  wire       VCOMPARE,    // voltage over capacitor
  output wire       VCHARGE,     // charge/discharge capacitor
  output wire       TX,          // serial transmission line
  output wire       SCK,         // serial clock to PGA
  output wire       SDI,         // serial data to PGA
  output wire       CSN);        // chip select (low active) to PGA
/**********************************************************************************************************************/