onerror {resume}
quietly WaveActivateNextPane {} 0
add wave -noupdate -label OSC_CLK /TB/i_uut/OSC_CLK
add wave -noupdate -label PO_RSTN /TB/i_uut/PO_RSTN
add wave -noupdate -label PB_RSTN /TB/i_uut/PB_RSTN
add wave -noupdate -label SWITCH -radix unsigned /TB/i_uut/SWITCH
add wave -noupdate -label LED -radix unsigned /TB/i_uut/LED
add wave -noupdate -divider {clock conditioning}
add wave -noupdate -label LOCK /TB/i_uut/LOCK
add wave -noupdate -label CLK /TB/i_uut/CLK
add wave -noupdate -label RSTN /TB/i_uut/RSTN
add wave -noupdate -label DCLK /TB/i_uut/DCLK
add wave -noupdate -label DRSTN /TB/i_uut/DRSTN
add wave -noupdate -divider opamp
add wave -noupdate -format Analog-Step -height 50 -label VP -max 2.0 -min 1.0 /TB/vpr
add wave -noupdate -format Analog-Step -height 50 -label VN -max 2.0 -min 1.0 /TB/vnr
add wave -noupdate -label {COMPARE [unregistered]} /TB/i_opamp/VP
add wave -noupdate -label COMPARE /TB/i_uut/COMPARE
TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {0 ps} 0}
quietly wave cursor active 0
configure wave -namecolwidth 168
configure wave -valuecolwidth 38
configure wave -justifyvalue left
configure wave -signalnamewidth 0
configure wave -snapdistance 10
configure wave -datasetprefix 0
configure wave -rowmargin 4
configure wave -childrowmargin 2
configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40
configure wave -timeline 0
configure wave -timelineunits us
update
WaveRestoreZoom {0 ps} {210 us}
