-- Actel Corporation Proprietary and Confidential
--  Copyright 2008 Actel Corporation.  All rights reserved.
-- ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN
-- ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED
-- IN ADVANCE IN WRITING.
--  Revision Information:
-- Jun09    Revision 4.1
-- Aug10    Revision 4.2
-- SVN Revision Information:
-- SVN $Revision: 8508 $
-- SVN $Date: 2009-06-15 16:49:49 -0700 (Mon, 15 Jun 2009) $
library ieee;
use ieee.STD_logic_1164.all;
use IEEE.STD_LOGIC_arith.all;
use ieee.std_logic_UNSIGNED.all;
entity myUART_myUART_0_Tx_asYNC is
generic (TX_FIFO: INTEGER := 0); port (clk: in std_logic;
CUARTL: in STD_LOGIc;
RESEt_n: in std_logic;
CUARTI0L: in STD_logic;
CUARTO1l: in STD_LOGIC_VEctor(7 downto 0);
CUARTl1l: in std_LOGIC_VECTOR(7 downto 0);
CUARTi1l: in std_logic;
CUARTOOI: in STD_LOGIC;
bit8: in std_logic;
Parity_en: in Std_logic;
odd_n_even: in std_logic;
txrdy: out Std_logic;
TX: out std_loGIC;
CUARTLOI: out std_LOGIC);
end entity myUART_myUART_0_TX_ASYNC;

architecture CUARTI1 of myUART_myUART_0_Tx_async is

constant CUARTi01i: INTEGER := 0;

constant CUARTo11i: integer := 1;

constant CUARTL11I: INTEGer := 2;

constant CUARTI11I: INTEGER := 3;

constant CUARTooo0: integer := 4;

constant CUARTlOO0: INTEGER := 5;

constant CUARTIOO0: INTEGER := 6;

signal CUARTolo0: integer;

signal CUARTLLO0: STD_logic;

signal CUARTIlo0: std_logIC_VECTOR(7 downto 0);

signal CUARToio0: STD_logic_vector(3 downto 0);

signal CUARTlio0: std_logIC;

signal CUARTIIO0: STD_LOgic;

signal CUARTo0o0: std_logic;

signal CUARTl0o0: std_logiC;

function TO_INTeger(VAL: STD_logic_vector)
return iNTEGER is
constant CUARTi01l: std_logic_vecTOR(val'high-val'low downto 0) := val;
variable CUARTo11l: integer := 0;
begin
for CUARTl11l in CUARTI01L'range
loop
if (CUARTI01L(CUARTl11l) = '1') then
CUARTO11L := CUARTO11l+(2**CUARTL11l);
end if;
end loop;
return (CUARTo11L);
end to_integer;

begin
TXrdy <= CUARTO0o0;
tx <= CUARTL0O0;
CUARTI0O0:
process (CLK,RESET_N)
begin
if (not reset_n = '1') then
CUARTllo0 <= '1';
elsif (clk'event and CLK = '1') then
if (TX_FIfo = 2#0#) then
if (CUARTl = '1') then
if (CUARTolO0 = CUARTL11I) then
CUARTLLO0 <= '1';
end if;
end if;
if (CUARTi0l = '1') then
CUARTLLO0 <= '0';
end if;
else
CUARTllo0 <= not CUARTOOI;
end if;
end if;
end process CUARTi0o0;
CUARTo1o0:
process (CLK,RESET_N)
begin
if (not reset_n = '1') then
CUARTOLO0 <= CUARTi01i;
CUARTilo0 <= "00000000";
CUARTiio0 <= '1';
elsif (CLK'EVENT and clk = '1') then
if (CUARTL = '1' or CUARTOLO0 = CUARTI01I
or CUARTOLO0 = CUARTIOO0
or CUARToLO0 = CUARTo11I) then
CUARTiIO0 <= '1';
case CUARTOlo0 is
when CUARTI01I =>
if (TX_FIFO = 2#0#) then
if (not CUARTllo0 = '1') then
CUARTOLO0 <= CUARTO11I;
else
CUARTOLO0 <= CUARTi01i;
end if;
else
if (CUARTi1l = '0') then
CUARTiio0 <= '0';
CUARTolO0 <= CUARTioo0;
else
CUARTolo0 <= CUARTI01i;
CUARTIIO0 <= '1';
end if;
end if;
when CUARTo11i =>
CUARTOLO0 <= CUARTL11i;
when CUARTL11I =>
if (TX_FIfo = 2#0#) then
CUARTilo0 <= CUARTo1L;
else
CUARTILO0 <= CUARTL1L;
end if;
CUARTolo0 <= CUARTi11i;
when CUARTI11i =>
if (bit8 = '1') then
if (CUARTOIO0 = "0111") then
if (PARITY_En = '1') then
CUARTolo0 <= CUARTooo0;
else
CUARTolo0 <= CUARTloo0;
end if;
else
CUARTOLO0 <= CUARTI11I;
end if;
else
if (CUARTOIO0 = "0110") then
if (Parity_en = '1') then
CUARTolo0 <= CUARTooo0;
else
CUARTolo0 <= CUARTloo0;
end if;
else
CUARTolo0 <= CUARTi11i;
end if;
end if;
when CUARTooo0 =>
CUARTOLO0 <= CUARTLOO0;
when CUARTloo0 =>
CUARTOLO0 <= CUARTI01I;
when CUARTioo0 =>
CUARTOLO0 <= CUARTO11I;
when others =>
CUARTolo0 <= CUARTI01i;
end case;
end if;
end if;
end process CUARTo1o0;
CUARTloi <= CUARTIIO0;
CUARTL1O0:
process (Clk,REset_n)
begin
if (not reset_N = '1') then
CUARTOIO0 <= "0000";
elsif (clk'Event and CLK = '1') then
if (CUARTL = '1') then
if (CUARTOlo0 /= CUARTi11i) then
CUARToio0 <= "0000";
else
CUARTOIO0 <= CUARToio0+"0001";
end if;
end if;
end if;
end process CUARTl1o0;
CUARTI1O0:
process (clk,reset_n)
begin
if (not rESET_N = '1') then
CUARTL0O0 <= '1';
elsif (CLK'EVENT and clk = '1') then
if (CUARTl = '1' or CUARTolo0 = CUARTi01i
or CUARTolo0 = CUARTioo0
or CUARTolo0 = CUARTo11i) then
case CUARTOLo0 is
when CUARTI01I =>
CUARTL0O0 <= '1';
when CUARTO11I =>
CUARTl0o0 <= '1';
when CUARTl11i =>
CUARTL0O0 <= '0';
when CUARTI11I =>
CUARTL0o0 <= CUARTilo0(TO_INTeger(CUARTOIO0));
when CUARTOOO0 =>
CUARTl0o0 <= ODD_N_EVEN xor CUARTlio0;
when CUARTloo0 =>
CUARTL0O0 <= '1';
when others =>
CUARTl0o0 <= '1';
end case;
end if;
end if;
end process CUARTI1O0;
CUARTOOL0:
process (clk,reset_n)
begin
if (not RESET_n = '1') then
CUARTlio0 <= '0';
elsif (CLK'evENT and CLk = '1') then
if ((CUARTL and parITY_EN) = '1') then
if (CUARTolo0 = CUARTI11I) then
CUARTlio0 <= CUARTlio0 xor CUARTilo0(TO_INTEGER(CUARTOIO0));
else
CUARTlio0 <= CUARTLio0;
end if;
end if;
if (CUARTOLO0 = CUARTloo0) then
CUARTLio0 <= '0';
end if;
end if;
end process CUARTOol0;
CUARTo0o0 <= CUARTLLO0;
end architecture CUARTI1;
